import logging
from pathlib import Path

from typing import List

from ec2init import Procedure

logger = logging.getLogger(__name__)

class CleanupPreinitCheck(Procedure):
    def __init__(self, name: str, check_files: List[Path]) -> None:
        self.name = name
        self.check_files = check_files

    def pre(self) -> None:
        pass
    
    def execute(self) -> List[Procedure]:
        logger.info("%s - Starting execution", self.name)
        try:
            for file in self.check_files:
                if file.is_file():
                    file.unlink()
            
        except Exception as ex:
            logger.warning("%s - Could not delete pre init check file.", ex)
            raise ex

        logger.info("%s - Finished my task!", self.name)
        return []

        
    def rollback(self) -> None:
        pass