import logging
import importlib

from typing import Any

logger = logging.getLogger(__name__)

class CommonUtils:

    @staticmethod
    def load_class(canonical_class_name: str) -> Any:
        """
        Dynamically load a class given its canonical name
        """
        tokenized = canonical_class_name.split(".")
        module_name = ".".join(tokenized[:len(tokenized) - 1])
        class_name = tokenized[len(tokenized) - 1]
        logger.debug("Loading class: %s", canonical_class_name)

        module = importlib.import_module(module_name)
        return getattr(module, class_name)