import logging
import xml.etree.ElementTree as ET

logger = logging.getLogger(__name__)


class HopsFSUtils:
    @staticmethod
    def fix_hdfs_site(prop_name:str , prop_value:str ) -> None:
        hdfs_site_xml = "/srv/hops/hadoop/etc/hadoop/hdfs-site.xml"
        found = False
    
        tree = ET.parse(hdfs_site_xml)
        root = tree.getroot()
    
        for p in root.iter('property'):
            if p[0].text == prop_name:
                logger.warn("%s is already defined in the hdfs-site.xml with value: %s. New value: %s ", prop_name, p[1].text, prop_value)
                p[1].text = prop_value #overwrite the value
                found = True
                tree.write(open(hdfs_site_xml, 'w'), encoding='unicode')
                break
        
        if not found:
            new_child = ET.Element("property")
            new_child.append(ET.Element("name"))
            new_child.append(ET.Element("value"))
            new_child[0].text = prop_name 
            new_child[1].text = prop_value 
            root.append(new_child)
            tree.write(open(hdfs_site_xml, 'w'), encoding='unicode')
            logger.info("Added %s property to hdfs-site.xml. Value: %s", prop_name, prop_value)